Bug 603340 - "python: Objects/frameobject.c:633: PyFrame_New: Assertion `f->f_code == code' failed.\n" running /usr/bin/gpo sync
"python: Objects/frameobject.c:633: PyFrame_New: Assertion `f->f_code == code...
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: pygobject2 (Show other bugs)
13
x86_64 Linux
low Severity medium
: ---
: ---
Assigned To: Colin Walters
Fedora Extras Quality Assurance
abrt_hash:ce1b1a84a86e9fb91002b6334ef...
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-06-12 09:14 EDT by Dave King
Modified: 2011-06-27 14:04 EDT (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-06-27 14:04:48 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
File: backtrace (56.45 KB, text/plain)
2010-06-12 09:14 EDT, Dave King
no flags Details

  None (edit)
Description Dave King 2010-06-12 09:14:09 EDT
abrt 1.1.1 detected a crash.

architecture: x86_64
Attached file: backtrace
cmdline: /usr/bin/python /usr/bin/gpo sync
comment: This used to work on F13.  After a recent update, I'm not sure which one, it started doing this.
component: gpodder
crash_function: raise
executable: /usr/bin/python
global_uuid: ce1b1a84a86e9fb91002b6334ef6d37ae33456c8
kernel: 2.6.33.5-112.fc13.x86_64
package: gpodder-2.5-1.fc13
rating: 4
reason: Process /usr/bin/python was killed by signal 6 (SIGABRT)
release: Fedora release 13 (Goddard)

How to reproduce
-----
1. Run gpodder command: "gpo sync"
Comment 1 Dave King 2010-06-12 09:14:12 EDT
Created attachment 423497 [details]
File: backtrace
Comment 2 Ville-Pekka Vainio 2010-06-14 13:36:02 EDT
I can't reproduce this with a filesystem based player, but it seems like python is raising an assertion. Assigning to the python package.
Comment 3 Dave Malcolm 2010-06-30 18:09:59 EDT
Thank you for reporting this bug.

How reproducible is this problem?  If you run the program from a terminal, is an error message printed?

What is the output of running the following command?
  rpm -q python python-libs python-debuginfo pygobject2

Looking at the backtrace, it looks like an assertion failed inside frame 2 of thread #1 inside PyFrame_New:
python: Objects/frameobject.c:633: PyFrame_New: Assertion `f->f_code == code' failed.

Frames #11 and above seem to be in GStreamer, IIRC frame #10 pyg_closure_marshal is in pygbject: a gstreamer callback is invoked, which turns out to be Python code, and it looks like the python code isn't valid.

The assertion that's failing is within this code:
	if (code->co_zombieframe != NULL) {
		f = code->co_zombieframe;
		code->co_zombieframe = NULL;
		_Py_NewReference((PyObject *)f);
		assert(f->f_code == code);
	}

The interpreter sees that the PyCodeObject has already had a PyFrameObject allocated that's no longer used, and tries to use that, rather than allocate a new PyFrameObject (an optimization), but the reused PyFrameObject doesn't point back at the PyCodeObject: something's gone wrong.

This could be:
- (i) a bug in the C code in /usr/lib64/python2.6/site-packages/gpod/_gpod.so that corrupts the internals of the process and happens to hit this value
- (ii) a bug in the way pygobject is setting up these callbacks
- (iii) a bug in python (but it would have to be very hard to reproduce)
- (iv) something else I haven't thought of

Reassigning component from "python" to "pygobject2" since I know we had a few issues with pygobject2 in the run-up to F-13.  Feel free to reassign back as necessary.
Comment 4 Dave King 2010-07-05 20:26:25 EDT
(In reply to comment #3)
> How reproducible is this problem?  If you run the program from a terminal, is
> an error message printed?

This abend occurs every time I run gpo (gpodder).  It's 100% reproduceable.  Here's the output from the console:

$ gpo sync
Plugin loaded: gpodder.soundcloud
Opening iPod database
iPod opened
Synchronizing: 1 of 10
Adding Top Gear - 2010-04-26
Synchronizing: 2 of 10
Adding Frontline - The Vaccine War - 2010-04-27
Synchronizing: 3 of 10
Adding House - The Choice - 2010-05-03
Synchronizing: 4 of 10
Adding Frontline - College, Inc. - 2010-05-04
Synchronizing: 5 of 10
Adding House - Baggage - 2010-05-10
Synchronizing: 6 of 10
Adding House - Help Me - 2010-05-27
Synchronizing: 7 of 10
Adding Burn Notice - Made Man - 2010-06-17
python: Objects/frameobject.c:633: PyFrame_New: Assertion `f->f_code == code' failed.
Aborted (core dumped)
$

> What is the output of running the following command?
>   rpm -q python python-libs python-debuginfo pygobject2

$ rpm -q python python-libs python-debuginfo pygobject2
python-2.6.4-27.fc13.x86_64
python-libs-2.6.4-27.fc13.x86_64
package python-debuginfo is not installed
pygobject2-2.21.1-6.fc13.x86_64
Comment 5 Bug Zapper 2011-06-02 07:07:51 EDT
This message is a reminder that Fedora 13 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 13.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '13'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 13's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 13 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 6 Bug Zapper 2011-06-27 14:04:48 EDT
Fedora 13 changed to end-of-life (EOL) status on 2011-06-25. Fedora 13 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.